/*   C++ Programs for illustration
     Several programs are based on slides/material by
     earlier course instructors
     Prof Milind Sohoni, Prof S Sudarshan, and Prof Abhiram Ranade
     
     The sample programs on Graphics also use sample code
     in the original EzWindow documentation
     
     Compiled by Prof Deepak B Phatak, 
     dept of CSE, Kanwal Rekhi Building, IIT Bombay
   
   
s6.cpp : 
    Illustrates opening a window and displaying various shapes
 #include <iostream>
#include "ezwin.h"
#include "position.h"
#include "rect.h"
#include "circle.h"
#include "triangle.h"
#include "square.h"
#include "wobject.h"
#include "shape.h"
#include "bitmap.h"
#include "label.h"
using namespace std;
SimpleWindow W ("This is a drawing", 15, 15);
int ApiMain()
{
    char mychar;
    int myint;
    Position x[2];
    cout << "Welcome. Enter an integer ";
    cin >> myint;
    // These happen before you draw your window
    W.Open();
    RectangleShape R1 (W, 4, 7, Red, 5, 6);
    R1.Draw();
    RectangleShape R2 (W, 4, 7, Red, 2, 3);
    R2.Draw();
    R2.Erase();
    R2.ClearBorder();
    RectangleShape R3 (W, 9, 12, Red, 3, 1);
    R3.Draw();
    CircleShape C (W, Position (8, 5), Blue, 1);
    C.Draw();
    TriangleShape T(W, Position(8,3), Green, 4);
    T.Draw();
    W.RenderLine(Position(6.0,7.0), Position(10.0,10.0),Black,0.1);
    cout << "Welcome.  Enter a character ";
    cin >> mychar; // these happen after you draw
    W.Close();
    return 0;
}*/

#include<iostream>
#include <cmath>                                                  
#include "assert.h"
#include <ezwin.h>
#include <cassert>
#include "rect.h"
#include "circle.h"
#include "bitmap.h"

SimpleWindow W1("Projectile",30,30,Position(0,0));//opens up the window
int n=0;

Position p2;

float range,tana,extnsn,sina,cosa,x2,y2;
        float xcur;
	float ycur;
	float x=3.7;
	float y=7.5;

	float velocity;
BitMap ball(W1);

float time1;
void resettime (){ time1=0;}

const int g=2;//this is taken as accln. due to gravity.

		

int projectile(float x,float y,float& xcur,float& ycur) //function for projectile motion.
{
 	
	//velocity is selected proportional to extension.
	float vx;
	float vy;
	
	vx=cosa*velocity;
	vy=sina*velocity;
	xcur=x +vx * time1;
	ycur=y -vy * time1 + (0.5 * g * time1 * time1);
	time1=time1+0.01;
	return 1;
}
	
	//float vx;
	//float vy;
	
int Getvel(int a)
{
	return 2*a;
}

  


int W1MouseClick(const Position &p) {
	
	p2=p;
	float x1=p.GetXDistance();
	float y1=p2.GetYDistance();
        
                
	 cout<<x1<<endl;
	 cout<<y1<<endl;      
	if(((x1-4.5)*(x1-4.5)+(y1-1.4)*(y1-1.4))<3.5)//condition to check whether p lies within"throw ball"
	{resettime();
	   xcur=x;ycur=y;
         while((xcur<x + 2 + range)) 
	{	
				
				projectile( x, y, xcur,ycur);	
				usleep(1000);	
				ball.Erase();

    W1.RenderLine(Position(4.0,10.0), Position(3.0,7.35424),
                        Black, 0.10);
    W1.RenderLine(Position(4.0,10.0), Position(6.0,8.0),
                        Red, 0.10);
    W1.RenderLine(Position(4.0,10.0), Position(4.0,11.60555),
                        Blue, 0.10);
				ball.SetPosition(Position(xcur,ycur));
				ball.Draw();
				CircleShape C (W1, Position (4.5, 1.4), Magenta, 2);
        C.Draw();                
                                             
        W1.RenderText(Position(2.8,1.4), Position(6.2,1.4),
	 "throw ball", Black);
	 W1.RenderLine(Position(3.0,7.35424), Position(x2,y2),
                        White, 0.09);
                        
	W1.RenderLine(Position(6.0,8.0), Position(x2,y2),
                        White, 0.09);
	 W1.RenderLine(Position(4.0,10.0), Position(3.0,7.35424),
                        Black, 0.10);
        W1.RenderLine(Position(4.0,10.0), Position(6.0,8.0),
                        Red, 0.10);
    W1.RenderLine(Position(4.0,10.0), Position(4.0,11.60555),
                        Blue, 0.10);
	
				
	}
	
	usleep(10000000/4);
	ball.Erase();
	ball.SetPosition(Position(3.7,7.5));
	ball.Draw();
	
	
	          }  //if closes
	
	
	
	else {        
	ball.Erase();
	ball.SetPosition(p);
	W1.RenderLine(Position(3.0,7.35424), Position(x2,y2),
                        White, 0.09);
                        
	W1.RenderLine(Position(6.0,8.0), Position(x2,y2),
                        White, 0.09);
	
	W1.RenderLine(Position(4.0,10.0), Position(3.0,7.35424),
                        Black, 0.10);
        W1.RenderLine(Position(4.0,10.0), Position(6.0,8.0),
                        Red, 0.10);
    
        W1.RenderLine(Position(4.0,10.0), Position(4.0,11.60555),
                        Blue, 0.10);
                        
                        CircleShape C (W1, Position (4.5, 1.4), Magenta, 2);
        C.Draw();                
                                             
        W1.RenderText(Position(2.8,1.4), Position(6.2,1.4),
	 "THROW BALL", Black);
	 
	W1.RenderLine(Position(3.0,7.35424), Position(x1,y1),
                        Green, 0.09);
                        
	W1.RenderLine(Position(6.0,8.0), Position(x1,y1),
                        Green, 0.09);
	ball.Draw();
	
	x2=p.GetXDistance();
	y2=p.GetYDistance();
	
	
	
	     }
	      





             
        
                        
                        	
	 
	
	                
    	tana=(y1-y)/(x-x1);
         
         
        extnsn=sqrt(((y1-y)*(y1-y)+(x1-x)*(x1-x)));
         
        sina=sqrt((tana*tana)/(1+tana*tana));
         
         
	cosa=sqrt((1/(1+tana*tana)));
	 
	 
	 
	 
	velocity=Getvel(extnsn);
	 
	 
	 
	range=velocity*velocity*2*sina*cosa/g;
	 
	 		
	ball.Draw();
	
	 
 	return 1;
}
  
int ApiMain()
{	
	W1.Open(); 

        W1.RenderLine(Position(4.0,10.0), Position(3.0,7.35424),
                        Black, 0.10);
        W1.RenderLine(Position(4.0,10.0), Position(6.0,8.0),
                        Red, 0.10);
        W1.RenderLine(Position(4.0,10.0), Position(4.0,11.60555),
                        Blue, 0.10);
	
	ball.SetPosition(Position(3.7 ,7.5));
	ball.Load("sohoni.xpm");
	ball.Draw();
	CircleShape C (W1, Position (4.5, 1.4), Magenta, 2);
        C.Draw();                
                                             
        W1.RenderText(Position(2.8,1.4), Position(6.2,1.4),
	 "THROW BALL", Black); 
		
	
		
	
	

	time1=0;
	
	
	
	W1.SetMouseClickCallback(W1MouseClick);
	 

	                return 0;
                                                                }

	



