//program overview..
#include<iostream>                                                          //header files included
#include "ezwin.h"
#include <cassert>
#include <cmath>                                                  
#include "assert.h"
#include "rect.h"
#include "circle.h"
#include "bitmap.h"
#include <stdio.h>
#include <stdlib.h>
using namespace std;

SimpleWindow W1("Projectile",20,20,Position(1.0,1.0));                      //welcome screen
SimpleWindow W2("Projectile",20,20,Position(1.0,1.0));                      //main menu screen
SimpleWindow W3("Projectile",25,10,Position(1.0,1.0));                      //window screen for showing instructions
SimpleWindow MyWindow("Projectile",25,30,Position(1.0,1.0));                //play window screen
Position p2;                                                                //object of class Position

BitMap ball(MyWindow);
float time1;                                                             //variable for time defined
//int n=0;                                                                //global variable
const int g=2;                                                         //acceleration due to gravity
	float xcur;                                                     // xcur n ycur are the coordinates of the centre of the ball at any instant
	float ycur; 	                                                //global variables
	float x=2.0;
	float y=9.0;
        const radius = 0.5;                                                     //keeping the rad constnt 
	float tana=0.00;
        time1=0.00;
        float extn=0.0;
	float xleft = 0.0;
        float xright = 0.0;
        float ybottom = 0.0;
        float ytop = 0.0;
	int level;
	float velocity;
/*
class game{                                                             //class of game
private:
int level;
public:
int getlevel();
};*/
//int game::getlevel()
//{ return level;}
/*class saved_game{
private:
int level;
public:
int getsavedlevel();
}
int saved_game::getsavedlevel()
{ return level;}*/
///////////////////////////////////////////////////////////////////////////////////////////
class basket{                                                                //class of basket
public:
pair<float,float> topRight,topLeft,bottomLeft,bottomRight;

void draw()
{

 //code for the rect basket 
 //Red Line, thickness 0
  MyWindow.RenderLine(Position(bottomLeft.first,bottomLeft.second),Position(bottomRight.first,bottomRight.second),Red,0.0);
  MyWindow.RenderLine(Position(bottomLeft.first,bottomLeft.second),Position(topLeft.first,topLeft.second),
		      Red,0.0);
  MyWindow.RenderLine(Position(bottomRight.first,bottomRight.second),Position(topRight.first,topRight.second),
		      Red,0.0);   
 //Blue Ellipse, border=true
  MyWindow.RenderEllipse( Position(topLeft.first,topLeft.second - 0.2),Position(topRight.first,topRight.second + 0.3),
			  Blue, true);
      
}

// function to set the coordinates of the basket
void setbasket( float,float,float,float);
};
 
 void basket::setbasket(xleft, xright, ybottom, ytop){
 topRight.first= xright;	topRight.second=ytop;
 topLeft.first=xleft;		topLeft.second=ytop;
 bottomLeft.first=xleft;	bottomLeft.second=ybottom;
 bottomRight.first=xright;	bottomRight.second=ybottom;
}


int bounce(int);
int playgame();



int projectile()                         //tana ,xcur,ycur,x,y are globally defined...   
{
 	//u is the initial velocity at time=0
	float ux;
	float uy;
	//float cosa=sqrt((1/(1+tan_angle*tan_angle)));
	ux=(cos(atan(tana)))*velocity;
	uy=(sin(atan(tana)))*velocity;
	xcur=x + ux * time1;
	ycur=y - uy * time1 + (0.5 * g * time1 * time1);
	time1=time1+0.01;
	return 1;
}

float Getvel(float a)
{
	return 2*a;
}



float Rangescale()
{
	 //velocity=extn*2.0;

	//float vx;                 nt requird
	//float vy;
	//float a= atan(tan_angle);
	//float cosa=sqrt((1/(1+tan_angle*tan_angle)));
        range = velocity*velocity*2*(sin(atan(tana)))*(cos(atan(tana)))/g;
	range = fabs(range);
        return range;
}
float maxheight( )
{ float h;
 float a = atan(tana);
 h = ((2.0*extn)*(2.0*extn)*(sin(a))*(sin(a)))/(2.0*g);
 return h;
} 

 highscore(int score1)                                         //this function takes care of the highest score of the game and displays the
{                                                              //same on the terminal.........
	int e;
	int highscore;			//score changed
	FILE *fp; FILE* fpout;
	char linestr[6]; char lineout[6];
		
	assert((fp = fopen("highscore.txt", "r" ))!= NULL);
	/*if (fp == NULL)
	{
	cout << "Could not open file" << endl;
	return -1;
	}*/

	/*Input file is open at this point, read records one by one */
	fgets(linestr, 5, fp);
  	     			//puts (linestr);
  	highscore = atoi(linestr);
 	fclose(fp); 

     if (score1 >= highscore)
    {
	fpout = fopen ("highscore.txt", "w");
	sprintf(lineout, "%3d",score);
	fputs(lineout,fpout);
	fclose(fpout);
	W3.Open(); 	
	W3.RenderText(Position(1.0,1.0), Position(12.0,3.0),
	 " CONGRATULATIONS.!!! YOUR SCORE IS NOW THE HIGHEST SCORE WHICH IS NOW", Red);
	float i=6.0;
	while( score1 != 0)
	{ e = score1%10;
	   
	   if( e == 0)
	   
	      { W3.RenderText(Position( i , 3.0), Position(i +4.0,4.0),
                                    "0",Red);      }                             	  
	 
	   else if ( e == 1)                 
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "1", Red);      }
           else if (e==2)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                            "2", Red);     }
           else if(e==3)
 	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "3", Red);      } 
           else if(e==4)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "4", Red);      }
           else if(e==5)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "5", Red);      }
           else if(e==6)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "6", Red);      }
           else if(e==7)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "7", Red);      }
           else if(e==8)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "8", Red);      }
           else if(e==9)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "9", Red);      }
		
	   score1 = score1 / 10;
	     i = i - 0.5;
	}

	cout<< “Your score: “<< score<<endl;
	cout<< “High Score: “<< highscore<<endl;
    }
  	cout << "inputfile has been read and printed\n";
  	return 0;
}


  int W2MouseClick( const Position &q)                 //mouse click function to choose the choice of the player..
	{ 
//	float x1=q.GetXDistance();
//	float y1=q.GetYDistance();
		if((q.GetXDistance()>5 && q.GetXDistance()<10)  && (q.GetYDistance()>6 && q.GetYDistance()<7))
		{
			 W3.Open();
			// Get Center of Window
			Position Center = W3.GetCenter();

			// Create bounding box for text
			Position UpperLeft = Center + Position(-1.0, -1.0);
	    		Position LowerRight = Center + Position(1.0,  1.0);	   
			
			 W3.RenderText(UpperLeft, LowerRight,
			 "Your goal is to throw the ball from the catapult into the basket.", Red);
			 W3.RenderText(UpperLeft +Position(1.0,1.0), LowerRight + Position(-1.0,1.0), 
			 "Just click on the desired position to throw the ball and confirm by clicking on the throw button.", Red);
  			 W3.RenderText(UpperLeft +Position(5.0,2.0), LowerRight + Position(-2.0,2.0),
  			 "If you succeed in any of the three chances, you move on to the next level!", Red);
  			 W3.RenderText(UpperLeft +Position(3.0,3.0), LowerRight + Position(-3.0,3.0),
  			 "GET...SET...GO!!!", Red);
  		}
		else if((q.GetXDistance()>5 && q.GetXDistance()<10)  && (q.GetYDistance()>5 && q.GetYDistance()<6))
		{	
			playgame();
		}
		else if((q.GetXDistance()>5 && q.GetXDistance()<10)  && (q.GetYDistance()>7 && q.GetYDistance()<8))
		{	//show the highest score
		}
		else if((q.GetXDistance()>5 && q.GetXDistance()<10)  && (q.GetYDistance()>5 && q.GetYDistance()<6))
		{       exit 0;
		}
  	return 1;
  	}	
   


	
  int MyWindowMouseClick(const Position &p)
    {
	
	ball.Erase();  // Erase the bitmap
	
	ball.SetPosition(p);
    	ball.Draw();
	float x1=p.GetXDistance();
	float y1=p.GetYDistance();
         tana=(y1-y)/(x-x1);          //x!=x1
         cout<<tana<<endl;
         extnsn=sqrt(((y1-y)*(y1-y))+((x1-x)*(x1-x)));
         cout<<extnsn<<endl;
         //sina=sqrt((tana*tana)/(1+tana*tana));
         
         cout<<sin(atan(tana))<<endl;
	 //cosa=sqrt((1/(1+tana*tana)));
	 cout<<cos(atan(tana))<<endl;
	 
	 
	 
	 velocity=Getvel(extnsn);
	 
	 
	 cout<<velocity<<endl;
	 
	 
	 range=velocity*velocity*2*sin(atan(tana))*cos(atan(tana))/g;
	 cout<<range<<endl;
	/* while(xcur<x + 1 +range)
        	{	
				
				projectile();	
				usleep(1000);	
				ball.Erase();
				ball.SetPosition(Position(xcur,ycur));
				ball.Draw();
				
	        }*/
	return 1;
    } 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 
int ApiMain()
{	
	W1.Open();
			//user driven menu interface	

	// Get Center of Window
	Position Center = W1.GetCenter();

	// Create bounding box for text
	Position UpperLeft = Center + Position(-1.0, -1.0);
	Position LowerRight = Center + Position(1.0,  1.0);

	// Display the text
	W1.RenderText(UpperLeft, LowerRight,
	 "Hello world..Get ready to play the game ", Red);
	
	W1.RenderText(UpperLeft +Position(1.0,1.0), LowerRight + Position(-1.0,1.0),
	 "BASKET BALL ", Red);
	sleep(5);
	
	W1.Close();

        W2.Open();
	W2.RenderRectangle(Position(5.0,5.0), Position(10.0,6.0),
			   Yellow, true);
	W2.RenderRectangle(Position(5.0,6.0), Position(10.0,7.0),
			   Yellow, true);
	W2.RenderRectangle(Position(5.0,7.0), Position(10.0,8.0),
			   Yellow, true);
	W2.RenderRectangle(Position(5.0,8.0), Position(10.0,9.0),
			   Yellow, true);
	// Display the text
	W2.RenderText(Position(3.0,6.0), Position(12.0,3.0),
	 "MAIN MENU", Red);
	W2.RenderText(Position(5.0,7.0), Position(9.5,4.0),
	 "1.NEW GAME", Red);
	W2.RenderText(Position(5.0,7.8), Position(10.0,5.0),
	 "2.INSTRUCTIONS", Red);
	W2.RenderText(Position(5.0,8.8), Position(10.0,6.0),
	 "3.HIGHEST SCORE", Red);
	W2.RenderText(Position(5.0,10.0), Position(10.0,7.0),
	 "4.EXIT ", Red);	
	W2.RenderText(Position(5.0,11.2), Position(10.0,8.0),
	 "CLICK ON YOUR CHOICE", Red);
        //sleep(10);
	W2.SetMouseClickCallback(W2MouseClick);		
	
return 1;
}			
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


	
int playgame()
{     basket B[3];
                                                                           
     int n=0;
     float R = 0.0;    
     float H = 0.0;         
     int score=0,chance,pass,check;
     	
	//initialpara(&extn,&tana);

  for(level=1;level<4;level++)
  {  MyWindow.Open();
     
     pass=0;
     xleft = 9 + level;
     xright = 11 + level;
     ybottom = y1 + level - 1;
     ytop = y1 + level + 1;
     B[level-1].setbasket(xleft,xright,ybottom,ytop);
     B[level-1].draw();
                                                                      //draw the throw button             
                                                                          //draw the catapult here
     cout<<”your score is “”<<score;
                                                                        
     for(chance = 1;chance <4;chance ++)
     {	 ball.SetPosition(Position(x,y));
	 ball.Load("trbot-r.xpm");
    	 ball.Draw();	
	 check=0;
	 time1=0;	 
	 MyWindow.SetMouseClickCallback(MyWindowMouseClick); 	

 			//take input from user by mouse click function for xcur n ycur
         
	
	 //extn=1.0;
         // R = rangescale();                                 //call the functn to determyn the range
	 H = maxheight(tana);                                  // to determine the max height
			
	 //x=2.0;
	 //y=9.0;
        if(H < ybottom){ bounce(1);}                                      //for bounce functions we donot have to pass the xcur and ycur
				                                          //now show the projectile loop being made by grp 1  
	else
	{
		while(xcur<( x + 1.0 + range))
			{	
				usleep(10090);
				projectile(tana);		
				ball.Erase();
				ball.SetPosition(Position(xcur,ycur));
				ball.Draw();				
				if(ycur == ybottom)
				{         if(xcur >= R/2)
  					 { if(xcur <= xleft)
       				 	  { bounce(1);
					  }
  					 }	
                                }	

					else if( xleft – xcur == radius)
     				   	{ if(ycur <= ybottom && ycur >ytop)
	
					     bounce(2);
					}
					else if(fabs( sqrt ((xcur – xleft)*(xcur – xleft) + (ycur – ytop)*(ycur – ytop))- radius) < 0.001)
					bounce (3);
	
					else if((ycur==ytop)&&(xcur>xleft)&&(xcur < xright))
				 	{  bounce(4);
					    check = 1;
					}
			
					else if(fabs(sqrt ((xcur – xright)*(xcur – xright) + (ycur – ytop)*(ycur – ytop))- radius) < 0.001)
					 bounce(5);
		
					else if(xcur >= xright  && ytop – ycur > radius)
				 	bounce(6);
				
				        //ball.Draw();
			}
	 }
        	if (check ==1)
		{
		  	//cout<<”well done”;
		        pass =1;
			score = score + level * 10;
		}

	//char s;                                                             ////????????what is this for???

	//cin>>s;
	//////////////////////////////////                                  //till here we r in the same chance of the same level
    }   //end of one loop of chance
         
        if(pass != 1)
	  {cout<<"You cannot go to the next level.."<<endl;
           break;
          }


    }   //end of one loop of level
//      if we r including high score function as well, then
//      call the high score function here 

        highscore(score);
  return 1;
  }
/////////////////////	TESTED ///////////DONE /////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////
/*
 main()
{
 INT a
 cout<<"Hello world..Get ready to play the game BASKET THE BALL."<<endl;
 //menu driven interface
 cout<<"MAIN MENU "<<endl;
 cout<<"1.NEW GAME"<<endl;
 cout<<"2.Instructions"<<endl;
 cout<<"3.Highest Score"<<endl;
 cout<<"Press 0 to exit."<<endl;
 cout<<"Enter your choice.";
 */
cin>>a;
 switch(a)
{
  case 1 : cout<<"STARTING THE NEW GAME";
             playgame(); //projectile() function called;
              break;  
  case 2 : cout<<"instructons";
           break;
  
  case 3 : //show the highest score 
	   break;        
  case 0 : exit();
//after getting the coordinates of the ball 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*INSIDE THE MAIN LOOP THAT CONTROLS THE GAME LEVEL AND THE CHANCE
now wen v get the user input for the projectile of the ball v will call the projectile function that will project the ball by using a loop .
Before the loop is executed  …*/
/*playgame()
{   
                        
  const radius = 0.5;                                                     //keeping the rad constnt 
  int score=0,level,chance;
  for(level=1;level<4;level++)
  { int pass=0;
     float xleft = 9 + level;
     float xright = 11 + level;
     float ybottom = y1 + level - 1;
     float ytop = y1 + level + 1;
     basket B(xleft,xright,ybottom,ytop);
     B.draw();
                                                                           //draw the throw button             
                                                                          //draw the catapult here
     cout<<”your score is “”<<score;
     for(chance = 1;chance <4;chance ++)
       {
	int check=0;
	float R = rangescale( extn, tana);                                 //call the functn to determyn the range
	float H = maxheight(extn, tana);                                  // to determine the max height
	if(H < ybottom){ bounce(1);}
				//now show the projectile loop being made by grp 1
        else
 {
        projectile();			// ____________      //call the functn to strt the loop
	if(yball == ybottom)
	{ if(xball >= R/2)
  	{ if(xball <= xleft)
        	 { bounce(1);
		 }
  	}	
	}
	else if( xleft – xball == radius)
        	{ if(yball <= ybottom && yball >top)
	
		     bounce(2);
		}
	else if( sqrt ((xball – xleft)*(xball – xleft) + (yball – ytop)*(yball – ytop)) == radius)
		bounce (3);
	else if((yball==ytop)&&(xball>xleft)&&(xball < xright))
	 	{  bounce(4);
		    check = 1;
		}
	else if(sqrt ((xball – xright)*(xball – xleft) + (yball – ytop)*(yball – ytop)) == radius)
		 bounce(5);
		else if(xball >= xright  && ytop – yball > radius)
	 	bounce(6);
	}
	if (check ==1)
	{
	  	//cout<<”well done”;
		int pass =1;
		score = score + level * 10;
	}	
*/
	int bounce(int p)
	{       float a=atan(tana);
		float tangent,vx,vy;
	  	switch(p)
		case 1 :      
		 	while(xcur<( x + 1.0 + range ))                              /////this does not collide with the 
		{	
				usleep(10090);                                     ///floor but stops at the level of the level of the catapult.
				projectile(tana);		
				ball.Erase();
				ball.SetPosition(Position(xcur,ycur));
				ball.Draw();
		}                    

       	 							    //continue to project until  y=y1
	      	        					    //y1 is the level of the catapult 
                              break;
		
		case 2 : 	//vx = (-1)*(1/2)*vx;
       	                    
		        while(xcur<( x + 1.0 + range))                              /////this does collide with the 
		{	
				usleep(10090);                                     ///floor and nt stop at the level of the level of the catapult.
				projectile(tana);		
				ball.Erase();
				ball.SetPosition(Position((3.0 * x - xcur)/2.0,ycur));
				ball.Draw();
		}                    

			//call projectile till yball==y1.,,,,,here e=1/2
 			      break;
	  
		case 3 :     
                	       tangent = (B[level-1].topLeft.second-ycur)/(B[level-1].topLeft.first - xcur);
	        	       if (xcur < B[level-1].topLeft.first)   //tht is wen tangent >0
                	     { vx=(cos(a))*2.0*extn*(-1.0)*(1.0 - cos(atan(tangent)));
			       vy=((sin(a))*2.0*extn - g*time1)*(-1.0)*(1.0 - sin(atan(tangent)));
			      
                	     }  else {
					vx=(cos(a))*2.0*extn*(-1.0)*(1.0 - cos(atan(tangent)));
			       		vy=((sin(a))*2.0*extn - g*time1)*(-1.0)*(1.0 + sin(atan(tangent)));
                	              
  					//tan inverse funtns exist n follow thw rules of principle 	values,,
                
	                             }
				while(ycur < y + 1)                      //y1 is the level of the grnd...it is y + 1                             
			      {	
 				{ usleep(10090);                                    
		                		
				xcur=x +  vx * time1;
				ycur=y -vy * time1 + (0.5 * g * time1 * time1);
				time1=time1+0.01;
					
				ball.Erase();
				ball.SetPosition(Position(xcur,ycur));
				ball.Draw();
                       	      }
				break;
		case 4 :      
			    
				while(ycur < y + 1)                              /////basket the ball
 		          {
				usleep(10090);                                     
				projectile(tana);		
				ball.Erase();				
				ball.SetPosition(Position(xcur,ycur));
				ball.Draw();
				if((B[level-1].topRight.first - xcur ) == radius)
                                {
				 bounce(2);
				}                                
		                else{
				     continue;
                                    }				
				
			  }                     

       		 		   //continue to project until  y=y1
		 	      	   //y1 is the level of the catapult 
                              break;
				
		case 5 :      
			       tangent = (B[level-1].topRight.second-ycur)/(B[level-1].topRight.first - xcur);
	        	       if (xcur < B[level-1].topRight.first)   //tht is wen tangent >0
                	     { vx=(cos(a))*2.0*extn*(-1.0)*(1.0 - cos(atan(tangent)));
			       vy=((sin(a))*2.0*extn - g*time1)*(-1.0)*(1.0 - sin(atan(tangent)));
			      
                	     }  else {
					vx=(cos(a))*2.0*extn*(-1.0)*(1.0 - cos(atan(tangent)));
			       		vy=((sin(a))*2.0*extn - g*time1)*(-1.0)*(1.0 + sin(atan(tangent)));
                	              
  					//tan inverse funtns exist n follow thw rules of principle 	values,,
                
	                             }
				while(ycur < y + 1)                      //y1 is the level of the grnd...it is y + 1                             
			      {	
 				{ usleep(10090);                                    
		                				
				xcur=x +  vx * time1;
				ycur=y -vy * time1 + (0.5 * g * time1 * time1);
				time1=time1+0.01;
					
				ball.Erase();
				ball.SetPosition(Position(xcur,ycur));
				ball.Draw();
                       	      }
				break;
		case 6 :   
				while(xcur<( x + 1.0 + range))                               
			  {	
				usleep(10090);                                     
				projectile(tana);		
				ball.Erase();
				ball.SetPosition(Position(xcur,ycur));
				ball.Draw();
			  }                     

       		 		   //continue to project until  y=y1
		 	      	   //y1 is the level of the catapult 
                              break;
	return 1;			
	}
//////////////////bounce function terminated
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////                   //////////////////////////////////////////////////////////////////
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\                   \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\





int highscore(int score1)                                         //this function takes care of the highest score of the game and displays the
{                                                              //same on the terminal.........
	int e;
	int highscore;			//score changed
	FILE *fp; FILE* fpout;
	char linestr[6]; char lineout[6];
		
	assert((fp = fopen("highscore.txt", "r" ))!= NULL);
	/*if (fp == NULL)
	{
	cout << "Could not open file" << endl;
	return -1;
	}*/

	/*Input file is open at this point, read records one by one */
	fgets(linestr, 5, fp);
  	     			//puts (linestr);
  	highscore = atoi(linestr);
 	fclose(fp); 

	if (score1 >= highscore)
	{
	fpout = fopen ("highscore.txt", "w");
	sprintf(lineout, "%3d",score1);
	fputs(lineout,fpout);
	fclose(fpout);
	W3.Open(); 	
	W3.RenderText(Position(1.0,1.0), Position(20.0,3.0),
	 " CONGRATULATIONS.!!! YOUR SCORE IS NOW THE HIGHEST SCORE WHICH IS NOW", Red);
	float i=6.0;
	while( score1 != 0)
	{ e = score1%10;
	   
	   if( e == 0)
	   
	      { W3.RenderText(Position( i , 3.0), Position(i +4.0,4.0),
                                    "0",Red);      }                             	  
	 
	   else if ( e == 1)                 
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "1", Red);      }
           else if (e==2)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                            "2", Red);     }
           else if(e==3)
 	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "3", Red);      } 
           else if(e==4)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "4", Red);      }
           else if(e==5)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "5", Red);      }
           else if(e==6)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "6", Red);      }
           else if(e==7)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "7", Red);      }
           else if(e==8)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "8", Red);      }
           else if(e==9)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "9", Red);      }
		
	   score1 = score1 / 10;
	     i = i - 0.5;
	}

        
	//cout<< “Your score: “<< score1<<endl;
	//cout<< “High Score: “<< highscore<<endl;
	}
  	cout << "inputfile has been read and printed\n";
  	return 0;float i=6.0;
	while( score1 != 0)
	{ e = score1%10;
	   
	   if( e == 0)
	   
	      { W3.RenderText(Position( i , 3.0), Position(i +4.0,4.0),
                                    "0",Red);      }                             	  
	 
	   else if ( e == 1)                 
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "1", Red);      }
           else if (e==2)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                            "2", Red);     }
           else if(e==3)
 	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "3", Red);      } 
           else if(e==4)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "4", Red);      }
           else if(e==5)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "5", Red);      }
           else if(e==6)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "6", Red);      }
           else if(e==7)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "7", Red);      }
           else if(e==8)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "8", Red);      }
           else if(e==9)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "9", Red);      }
		
	   score1 = score1 / 10;
	     i = i - 0.5;
	}

}

int ApiMain()
{ 
  
int score = 100;

highscore(score);
  




return 1;

}




	
	
