/*   C++ Programs for illustration
     Several programs are based on slides/material by
     earlier course instructors
     Prof Milind Sohoni, Prof S Sudarshan, and Prof Abhiram Ranade
     
     The sample programs on Graphics also use sample code
     in the original EzWindow documentation
     
     Compiled by Prof Deepak B Phatak, 
     dept of CSE, Kanwal Rekhi Building, IIT Bombay
   
s5.cpp
   draws different shapes in a single window   
 

#include "ezwin.h"
#include <cassert>

// Define a window with title "Basic shapes", size 10cm x 10cm,
//     positioned 3cm from left, 1cm from top of screen.
SimpleWindow MyWindow("Basic shapes", 10.0, 10.0,
		      Position(3.0, 1.0));
int ApiMain() {
  MyWindow.Open();
  assert(MyWindow.GetStatus() == WindowOpen);

  // Colors: {White, Red, Green, Blue, Yellow, Cyan, Magenta};

  //Green Rectangle, with no border
  MyWindow.RenderRectangle(Position(1.0,1.0), Position(2.0,2.0),
			   Green, false);

  //Yellow Rectangle, with border
  MyWindow.RenderRectangle(Position(2.5,2.5), Position(5.0,6.0),
			   Yellow, true);

  //Red Line, thickness 0
  MyWindow.RenderLine(Position(3.0,0.0),Position(3.5,2.0),
		      Red,0.0);
//Red Line, thickness 0
  MyWindow.RenderLine(Position(3.0,3.0),Position(5.0,3.0),
		      Red,0.0);
  MyWindow.RenderLine(Position(3.0,3.0),Position(3.0,2.0),
		      Red,0.0);
  MyWindow.RenderLine(Position(5.0,3.0),Position(5.0,2.0),
		      Red,0.0);   

  //Blue Ellipse, border=true
  MyWindow.RenderEllipse( Position(3.0,1.8),Position(5.0, 2.3),
			  White, true);
  MyWindow.RenderEllipse( Position(3.0,2.8),Position(5.0, 3.3),
			  Red, true);
 
  return 0;
} // end ApiMain()
*/
//program overview..
#include<iostream>                                                          //header files included
#include "ezwin.h"
#include <cassert>
#include <cmath>                                                  
#include "assert.h"
#include "rect.h"
#include "circle.h"
#include "bitmap.h"
#include <stdio.h>
#include <stdlib.h>
using namespace std;

SimpleWindow W3("Projectile",25,10,Position(1.0,1.0));                      //window screen for showing instructions


int highscore(int score1)                                         //this function takes care of the highest score of the game and displays the
{                                                             //same on the terminal.........
	int e;
	int highscore;			//score changed
	FILE *fp; FILE* fpout;
	char linestr[6]; char lineout[6];
		
	assert((fp = fopen("highscore.txt", "r" ))!= NULL);
	/*if (fp == NULL)
	{
	cout << "Could not open file" << endl;
	return -1;
	}*/

	/*Input file is open at this point, read records one by one */
	fgets(linestr, 5, fp);
  	     			//puts (linestr);
  	highscore = atoi(linestr);
 	fclose(fp); 

	if (score1 >= highscore)
	{
	fpout = fopen ("highscore.txt", "w");
	sprintf(lineout, "%3d",score1);
	fputs(lineout,fpout);
	fclose(fpout);
	W3.Open(); 	
	W3.RenderText(Position(1.0,1.0), Position(20.0,3.0),
	 " CONGRATULATIONS.!!! YOUR SCORE IS NOW THE HIGHEST SCORE WHICH IS NOW", Red);
	float i=6.0;
	while( score1 != 0)
	{ e = score1%10;
	   
	   if( e == 0)
	   
	      { W3.RenderText(Position( i , 3.0), Position(i +4.0,4.0),
                                    "0",Red);      }                             	  
	 
	   else if ( e == 1)                 
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "1", Red);      }
           else if (e==2)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                            "2", Red);     }
           else if(e==3)
 	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "3", Red);      } 
           else if(e==4)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "4", Red);      }
           else if(e==5)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "5", Red);      }
           else if(e==6)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "6", Red);      }
           else if(e==7)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "7", Red);      }
           else if(e==8)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "8", Red);      }
           else if(e==9)
	      { W3.RenderText(Position(i,3.0), Position(i+4.0,4.0),
	                           "9", Red);      }
		
	   score1 = score1 / 10;
	     i = i - 0.5;
	}

        
	//cout<< “Your score: “<< score1<<endl;
	//cout<< “High Score: “<< highscore<<endl;
	}
  	cout << "inputfile has been read and printed\n";
  	return 0;
}

int ApiMain()
{ 
  
int score = 56;

highscore(score);
  




return 1;

}
